SystemOrganization addCategory: #'FuelPlatform-Squeak-Core'!

FLPlatform subclass: #FLSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Squeak-Core'!

!FLSqueakPlatform class methodsFor: 'private-extensions-string' stamp: 'MaxLeske 4/28/2016 17:08'!
=> anObject
	<flExtensionOf: #String>	
	^ anObject isBehavior
		ifTrue: [(Smalltalk globals at: #ClassBinding) key: self value: anObject]
		ifFalse: [(Smalltalk globals at: #Global) key: self value: anObject]! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 4/30/2016 14:06'!
addAbstractBinaryFileStream
	Smalltalk
		at: #AbstractBinaryFileStream
		ifPresent: [ :x | ^ self ].
		
	Stream subclass: #AbstractBinaryFileStream
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:40'!
addClusters
	Smalltalk
		at: #FLMethodContextCluster
		ifPresent: [ :x | ^ self ].
		
	FLVariableObjectCluster subclass: #FLMethodContextCluster
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addContext
	Smalltalk
		at: #Context
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Context
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addEnvironment
	"Don't name the category 'Fuel-Hacks'. That category will be nuked on load"	
	Smalltalk
		at: #Environment
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Environment
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-extensions-class' stamp: 'MaxLeske 4/28/2016 17:08'!
addInstVarNamed: aString
	<flExtensionOf: #Class>
	"Add the argument, aString, as one of the receiver's instance variables."
	^((Smalltalk globals at: #ClassBuilder) new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: self instanceVariablesString, ' ', aString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category
! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addNativeBoostComponents
	Smalltalk
		at: #NBExternalHandle
		ifPresent: [ :handle | ^ self ].
		
	Object variableByteSubclass: #NBExternalHandle
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ :manifest | ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addTraits
	(Smalltalk classOrTraitNamed: #TClass) ifNil: [
		Trait 
			named: #TClass
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TClassDescription) ifNil: [
		Trait 
			named: #TClassDescription
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TBehavior) ifNil: [
		Trait 
			named: #TBehavior
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TPureBehavior) ifNil: [
		Trait 
			named: #TPureBehavior
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TApplyingOnClassSide) ifNil: [
		Trait 
			named: #TApplyingOnClassSide
			uses: {}
			category: self hacksCategoryName ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-symbol' stamp: 'MaxLeske 2/20/2016 15:43'!
asMethodPreamble
	<flExtensionOf: #Symbol>
	self numArgs = 0 ifTrue: [ ^self asString].
	^ String streamContents: [ :str | 
		self keywords doWithIndex: [ :each :index | 
				str
					nextPutAll: each;
					nextPutAll: ' var' , index asString ] ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/19/2016 09:25'!
assertWellMaterializedInto: aMethodContext in: aTestCase
	<flExtensionOf: #MethodContext isSource: true>
	^ 'assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]'! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 4/30/2016 14:32'!
basicAddHacks
	super basicAddHacks.
	
	self
		addTraits;
		addEnvironment;
		addNativeBoostComponents;
		addContext;
		addClusters;
		addPackageManifest;
		addAbstractBinaryFileStream! !

!FLSqueakPlatform class methodsFor: 'private-extensions-protoobject' stamp: 'Maxleske 2/20/2016 18:41'!
basicIdentityHashForProtoObject
	<flExtensionOf: #ProtoObject selector: #basicIdentityHash>
	^ self identityHash! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:04'!
bytecodesHash
	<flExtensionOf: #CompiledMethod>
	"Answer a 16-bit checksum of the bytecodes."

	^ self crc16from: self initialPC to: self endPC! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:37'!
cleanCopy 
	<flExtensionOf: #MethodContext isSource: true>
	^ 'cleanCopy 
	^ self class 
		sender: nil 
		receiver: receiver 
		method: method
		arguments: #()'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:41'!
codeForNoSource
	<flExtensionOf: #CompiledMethod>
	"this is the marker we use for method that have no source"
	^ String streamContents: [:str |
		str 
			nextPutAll: self selector asMethodPreamble;
			cr;tab;
			nextPutAll: 'self methodHasNoSourceCode' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-bytearray' stamp: 'MaxLeske 2/20/2016 15:07'!
crc16from: start to: end
	<flExtensionOf: #ByteArray>
	"Compute a 16 bit cyclic redundancy check on the specified interval."

	| crc |
	crc := 0.
	start to: end do: [:i |
		crc := (crc bitShift: -8) bitXor: (
		 #(	16r0000	16rC0C1	16rC181	16r0140	16rC301	16r03C0	16r0280	16rC241
			16rC601	16r06C0	16r0780	16rC741	16r0500	16rC5C1	16rC481	16r0440
			16rCC01	16r0CC0	16r0D80	16rCD41	16r0F00	16rCFC1	16rCE81	16r0E40
			16r0A00	16rCAC1	16rCB81	16r0B40	16rC901	16r09C0	16r0880	16rC841
			16rD801	16r18C0	16r1980	16rD941	16r1B00	16rDBC1	16rDA81	16r1A40
			16r1E00	16rDEC1	16rDF81	16r1F40	16rDD01	16r1DC0	16r1C80	16rDC41
			16r1400	16rD4C1	16rD581	16r1540	16rD701	16r17C0	16r1680	16rD641
			16rD201	16r12C0	16r1380	16rD341	16r1100	16rD1C1	16rD081	16r1040
			16rF001	16r30C0	16r3180	16rF141	16r3300	16rF3C1	16rF281	16r3240
			16r3600	16rF6C1	16rF781	16r3740	16rF501	16r35C0	16r3480	16rF441
			16r3C00	16rFCC1	16rFD81	16r3D40	16rFF01	16r3FC0	16r3E80	16rFE41
			16rFA01	16r3AC0	16r3B80	16rFB41	16r3900	16rF9C1	16rF881	16r3840
			16r2800	16rE8C1	16rE981	16r2940	16rEB01	16r2BC0	16r2A80	16rEA41
			16rEE01	16r2EC0	16r2F80	16rEF41	16r2D00	16rEDC1	16rEC81	16r2C40
			16rE401	16r24C0	16r2580	16rE541	16r2700	16rE7C1	16rE681	16r2640
			16r2200	16rE2C1	16rE381	16r2340	16rE101	16r21C0	16r2080	16rE041
			16rA001	16r60C0	16r6180	16rA141	16r6300	16rA3C1	16rA281	16r6240
			16r6600	16rA6C1	16rA781	16r6740	16rA501	16r65C0	16r6480	16rA441
			16r6C00	16rACC1	16rAD81	16r6D40	16rAF01	16r6FC0	16r6E80	16rAE41
			16rAA01	16r6AC0	16r6B80	16rAB41	16r6900	16rA9C1	16rA881	16r6840
			16r7800	16rB8C1	16rB981	16r7940	16rBB01	16r7BC0	16r7A80	16rBA41
			16rBE01	16r7EC0	16r7F80	16rBF41	16r7D00	16rBDC1	16rBC81	16r7C40
			16rB401	16r74C0	16r7580	16rB541	16r7700	16rB7C1	16rB681	16r7640
			16r7200	16rB2C1	16rB381	16r7340	16rB101	16r71C0	16r7080	16rB041
			16r5000	16r90C1	16r9181	16r5140	16r9301	16r53C0	16r5280	16r9241
			16r9601	16r56C0	16r5780	16r9741	16r5500	16r95C1	16r9481	16r5440
			16r9C01	16r5CC0	16r5D80	16r9D41	16r5F00	16r9FC1	16r9E81	16r5E40
			16r5A00	16r9AC1	16r9B81	16r5B40	16r9901	16r59C0	16r5880	16r9841
			16r8801	16r48C0	16r4980	16r8941	16r4B00	16r8BC1	16r8A81	16r4A40
			16r4E00	16r8EC1	16r8F81	16r4F40	16r8D01	16r4DC0	16r4C80	16r8C41
			16r4400	16r84C1	16r8581	16r4540	16r8701	16r47C0	16r4680	16r8641
			16r8201	16r42C0	16r4380	16r8341	16r4100	16r81C1	16r8081	16r4040)
			 at: ((crc bitXor: (self byteAt: i)) bitAnd: 16rFF) + 1) ].
	^crc! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
defaultTimeout
	<flExtensionOf: #FLSerializationTest>
	"We have some long running tests which will be terminated by Squeaks
	implementation of TestCase>>runCase. Increase the default fro 5 to 60 seconds"
	
	^ 60 "seconds"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 4/28/2016 17:08'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 (Smalltalk globals at: #FileDirectory) default deleteFileNamed: aFilename! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:05'!
duringTestCompileSilently: code
	<flExtensionOf: #ClassDescription>
	^ self 
		duringTestCompileSilently: code 
		storeSource: true! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code classified: aCategory
	<flExtensionOf: #ClassDescription>
	^ self 
		duringTestCompileSilently: code
		storeSource: true
		classified: aCategory! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code storeSource: storeSource
	<flExtensionOf: #ClassDescription>
	^ self
		duringTestCompileSilently: code
		storeSource: storeSource
		classified: ''! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/21/2016 09:59'!
duringTestCompileSilently: code storeSource: storeSource classified: aCategory
	<flExtensionOf: #ClassDescription>
	^ FLPlatform current 
		useAuthor: 'TestsAuthor'
		during: [ [
			self 
				compile: code
				classified: (aCategory ifNil: [ '''' ])
				withStamp: nil 
				notifying: nil 
				logSource: storeSource ] fuelValueWithoutNotifications ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-gradientfillstyle' stamp: 'MaxLeske 2/19/2016 10:28'!
equals: anGradientFillStyle
	<flExtensionOf: #GradientFillStyle selector: #= >
	"Answer whether equal."

	^ self pixelRamp == anGradientFillStyle pixelRamp "LRU should make identity equal"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-collection' stamp: 'MaxLeske 2/20/2016 14:51'!
flatCollect: aBlock
	<flExtensionOf: #Collection>
	"Evaluate aBlock for each of the receiver's elements and answer the
	list of all resulting values flatten one level. Assumes that aBlock returns some kind
	of collection for each element. Equivalent to the lisp's mapcan"
	
	| stream |
	self isEmpty ifTrue: [ ^ self copy ].
	stream := (self species new: 0) writeStream.
	self do: [ :each | stream nextPutAll: (aBlock value: each) ].
	^ stream contents! !

!FLSqueakPlatform class methodsFor: 'private-extensions-environment' stamp: 'MaxLeske 2/20/2016 16:35'!
fuelAcceptForEnvironment: aGeneralMapper
	<flExtensionOf: #Environment selector: #fuelAccept:>
	"serialize all instances except for <Smalltalk globals>"
	^ self == Smalltalk globals 
		ifFalse: [ super fuelAccept: aGeneralMapper ]
		ifTrue: [ aGeneralMapper visitHookPrimitive: self ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 16:26'!
fuelAcceptForMethodContext: aGeneralMapper
	<flExtensionOf: #MethodContext selector: #fuelAccept:>
	^ aGeneralMapper visitMethodContext: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
fuelIgnoredInstanceVariableNames
	<flExtensionOf: #Behavior>
	"Indicates which variables have to be ignored during serialization."

	^#()! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
fuelNew
	<flExtensionOf: #Behavior>
	"Answer an instance of mine in which serialized references will be injected."

	^ self basicNew! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
fuelNew: sizeRequested
	<flExtensionOf: #Behavior>
	"Answer an instance of mine in which serialized references will be injected."

	^ self basicNew: sizeRequested! !

!FLSqueakPlatform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 4/28/2016 17:08'!
fuelValueWithoutNotifications
	<flExtensionOf: #BlockClosure>
	(Smalltalk globals at: #SystemChangeNotifier) uniqueInstance doSilently: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethodtrailer' stamp: 'MaxLeske 2/20/2016 15:39'!
hasSource
	<flExtensionOf: #CompiledMethodTrailer isSource: true>
	^ 'hasSource
	^ kind == #EmbeddedSourceQCompress or: [ kind == #EmbeddedSourceZip ]'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:53'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	<flExtensionOf: #MethodContext isSource: true>
	^ 'initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/20/2016 14:57'!
instVarIndexFor: instVarName
	<flExtensionOf: #ClassDescription>
	"Answer the index of the named instance variable."

	| index |
	index := instanceVariables == nil 
		ifTrue: [0]
		ifFalse: [instanceVariables indexOf: instVarName].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [0]
			ifFalse: [superclass instVarIndexFor: instVarName]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
instanceVariableNamesDo: anUnaryBlock
	<flExtensionOf: #ClassDescription>
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := self superclass notNil ifTrue: [self superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[self superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:04'!
isDoIt
	<flExtensionOf: #CompiledMethod>
	^ self selector isDoIt.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:40'!
isNamedPrimitive
	<flExtensionOf: #CompiledMethod>
	^ self primitive = 117! !

!FLSqueakPlatform class methodsFor: 'testing' stamp: 'TravisCI 2/20/2016 14:17'!
isResponsibleForCurrentPlatform
	^ SystemVersion current version beginsWith: 'Squeak'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-dateandtime' stamp: 'MaxLeske 2/20/2016 15:08'!
julianDayNumberUTC
	<flExtensionOf: #DateAndTime isSource: true>
	^ 'julianDayNumberUTC
	^ jdn'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-environment' stamp: 'MaxLeske 2/20/2016 16:39'!
materializeFromForEnvironment: aDecoder
	<flExtensionOf: #Environment selector: #materializeFrom:>
	<flExtensionClassSide>
	"Answer my well-known instance"

	^ (Smalltalk at: #Environment) default! !

!FLSqueakPlatform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/20/2016 14:55'!
methodNamed: aSelector
	<flExtensionOf: #Behavior>
	^ self methodDict at: aSelector! !

!FLSqueakPlatform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/20/2016 15:47'!
newFromFrameSize: aFrameSize
	<flExtensionOf: #ContextPart>
	<flExtensionClassSide>
	^ super basicNew: aFrameSize! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
newName
	<flExtensionOf: #ClassFactoryForTestCase>
	| postFix |
	postFix := (self createdClasses size + 1) printString.
	^(#ClassForTestToBeDeleted, postFix) asSymbol! !

!FLSqueakPlatform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 13:43'!
newSqueakPlatformAttributesSourceFrom: aCollection
	^ String streamContents: [ :stream | 
		stream nextPutAll: 'defaultPlatformAttributes
	| attributes versionString |
	attributes := OrderedCollection with: #squeakCommon with: #squeak.
	Smalltalk
		at: #SystemVersion
		ifPresent: [:cl | 
			versionString := cl current version.
			(versionString beginsWith: ''Squeak3.10'')
				ifTrue: [attributes add: #''squeak3.10.x''].
			(versionString beginsWith: ''Squeak4'')
				ifTrue: [attributes add: #''squeak4.x''.'.
		aCollection do: [ :version |
			stream
				nextPutAll: '(versionString beginsWith: ''';
				nextPutAll:  version;
				nextPutAll: ''') ifTrue: [ attributes add: #''';
				nextPutAll: version asLowercase;
				nextPutAll: '.x''] ifFalse: [ ' ].
		stream 
			nextPutAll: (String newFrom: ((1 to: aCollection size + 2) collect: [ :i | $] ]));
			nextPutAll: '. ^ attributes' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 4/28/2016 17:08'!
newSubclassNamed: nameString of: aClass  instanceVariableNames: ivNamesString classVariableNames: classVarsString
	<flExtensionOf: #FLSerializationTest>
	| class |
	(Smalltalk globals at: #SystemChangeNotifier) uniqueInstance doSilently: [
		class := aClass
			subclass: nameString asSymbol
			instanceVariableNames: ivNamesString
			classVariableNames:  classVarsString
			poolDictionaries: ''
			category: self classFactory defaultCategory
	].
	self classFactory createdClasses add: class.
	^ class! !

!FLSqueakPlatform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/20/2016 14:50'!
reduceRight: aBlock
	<flExtensionOf: #SequenceableCollection>
	"Fold the result of the receiver from right to left into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceRight: [ :a :b | a - b ].
		--> (1 - (2 - 3)) = 2
	#(1 + 3 - 5) reduceRight: [ :a :op :b | a perform: op with: b ].
		--> (1 + (3 - 5)) = -1"

	| arguments |
	self emptyCheck.
	arguments := Array new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: arguments size put: self last.
	self size - arguments size + 1 to: 1 by: 1 - arguments size do: [ :index |
		arguments
			replaceFrom: 1 to: aBlock argumentCount - 1 with: self startingAt: index;
			at: arguments size put: (aBlock valueWithArguments: arguments) ].
	^ arguments last! !

!FLSqueakPlatform class methodsFor: 'private-extensions-sourcefilearray' stamp: 'MaxLeske 2/20/2016 15:18'!
remoteStringAt: sourcePointer
	<flExtensionOf: #SourceFileArray>
	| filePosition fileIndex |
	fileIndex := self fileIndexFromSourcePointer: sourcePointer.
	filePosition := self filePositionFromSourcePointer: sourcePointer.	

	^ RemoteString newFileNumber: fileIndex position: filePosition! !

!FLSqueakPlatform class methodsFor: 'private-extensions-class' stamp: 'MaxLeske 4/28/2016 17:08'!
removeInstVarNamed: aString
	<flExtensionOf: #Class>
	"Remove the argument, aString, as one of the receiver's instance variables."

	| newInstVarString |
	(self instVarNames includes: aString)
		ifFalse: [self error: aString , ' is not one of my instance variables'].
	newInstVarString := ''.
	(self instVarNames copyWithout: aString) do: 
		[:varName | newInstVarString := newInstVarString , ' ' , varName].
	^((Smalltalk globals at: #ClassBuilder) new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: newInstVarString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
renameSilently: aName
	<flExtensionOf: #ClassDescription>
	 [ self rename: aName] fuelValueWithoutNotifications! !

!FLSqueakPlatform class methodsFor: 'private-extensions-date' stamp: 'MaxLeske 2/20/2016 16:29'!
serializeOnForDate: anEncoder
	<flExtensionOf: #Date selector: #serializeOn: isSource: true>
	^ 'serializeOn: anEncoder
	start serializeOn: anEncoder'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-dateandtime' stamp: 'MaxLeske 2/20/2016 17:03'!
serializeOnForDateAndTime: anEncoder
	<flExtensionOf: #DateAndTime selector: #serializeOn:>
	anEncoder 
		encodeUint32: self julianDayNumberUTC;
		encodeUint32: self nanoSecond;
		encodeInt24: self secondsSinceMidnight;
		encodeInt24: self offset asSeconds;
		encodeInt32: self offset nanoSeconds.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-environment' stamp: 'MaxLeske 2/20/2016 16:28'!
serializeOnForEnvironment: anEncoder
	<flExtensionOf: #Environment selector: #serializeOn:>
	"Do nothing"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: self defaultCategoryPostfix
! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: (self packageName, '-', category) asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:09'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString package: packageName
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: packageName asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-testcase' stamp: 'MaxLeske 2/20/2016 15:49'!
skip
	<flExtensionOf: #TestCase>! !

!FLSqueakPlatform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/20/2016 15:40'!
sourceCode
	<flExtensionOf: #CompiledMethod>
	"Retrieve or reconstruct the source code for this method."
	| trailer source |
	trailer := self trailer.
	trailer sourceCode ifNotNil: [:code | ^ code ].
	trailer hasSourcePointer ifFalse: [^ self codeForNoSource].

	"Situation normal;  read the sourceCode from the file"
	source := [self getSourceFromFile]
				on: Error
				do: [ :ex | ex return: nil].
	source isEmptyOrNil ifTrue: [^ self codeForNoSource].			
	^source! !

!FLSqueakPlatform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/20/2016 14:50'!
sum: aBlock
	<flExtensionOf: #SequenceableCollection>
	"This is implemented using a variant of the normal inject:into: pattern. 
	The reason for this is that it is not known whether we're in the normal 
	number line, i.e. whether 0 is a good initial value for the sum. 
	Consider a collection of measurement objects, 0 would be the unitless 
	value and would not be appropriate to add with the unit-ed objects."
	| sum sample |
	sample := aBlock value: self anyOne.
	sum := self inject: sample into: [ :previousValue :each |  previousValue + (aBlock value: each) ].
	^ sum - sample! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
tearDown
	<flExtensionOf: #FLSerializationTest>
	super tearDown.
	"Traits should be cleaned before classFactory because it seems class factory only knows how to clean classes, not traits."
	self tearDownTraits.
	self tearDownClassFactory.
	self tearDownGlobalVariables.
	self tearDownInstanceVariables! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
tearDownInstanceVariables
	<flExtensionOf: #FLSerializationTest>
	self class withAllSuperclasses do: [ :class |
		class = TestCase ifTrue: [ ^ self ].
		
		class instVarNames do: [ :varName |
			self 
				instVarNamed: varName
				put: nil ] ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:53'!
tempNamed: aName
	<flExtensionOf: #MethodContext>
	^ self tempAt: (self tempNames indexOf: aName)! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/20/2016 15:48'!
tempNamed: aName put: anObject
	<flExtensionOf: #MethodContext>
	^ self tempAt: (self tempNames indexOf: aName) put: anObject! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContext
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithClosureAndSender
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext2 context2 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self
		resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithNilPc
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: nil
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithSender
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 context2 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context2 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method2.
	context2
		initializeWith: 18
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method2
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 5;
				left: 6)
		sender: nil.
	context1 privSender: context2.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithTemp
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #methodWithTemp.
	context1
		initializeWith: nil
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #methodWithTemp
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
testDateOffsets
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.

	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
testDateOffsetsChanging
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 1 hours.
	self serialize: object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flmigrationtest' stamp: 'MaxLeske 4/30/2016 13:51'!
testFormatFixedToVariable
	"Tests that serializer can tolerate a format change from a *fixed* class to *weak/variable*.
	Notice, however, that the other way around (variable to fixed) doesn't work so far"

	<flExtensionOf: #FLMigrationTest>
	| materialized |
	self serialize:
		(Smalltalk globals at: #FLPair) new.
	materialized := [ self
		during: [ self materialized ]
		rename: (Smalltalk globals at: #FLPair)
		as: (Smalltalk globals at: #FLWeakClassMock) ]
		on: (Smalltalk globals at: #AttemptToWriteReadOnlyGlobal)
		do: [ :ex | ex resume: true ].
	self assert: materialized size = 0! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:09'!
withNotificationsNewClassWithInstanceVariableNames: instanceVariableNames
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self newSubclassOf: Object instanceVariableNames: instanceVariableNames classVariableNames:  '' category: self defaultCategoryPostfix
	! !

!FLSqueakPlatform methodsFor: 'accessing-system' stamp: 'MaxLeske 4/30/2016 15:35'!
absolutePathOf: aString
	^ (((Smalltalk globals at: #FileDirectory) forFileName: aString) / aString) fullName ! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/30/2016 12:34'!
deleteFileNamed: aFilename
	((Smalltalk at: #FileDirectory) forFileName: aFilename) deleteFileNamed: aFilename! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/29/2016 09:11'!
fileNamed: aFilename readStreamDo: aBlock
	^ FileStream
		readOnlyFileNamed: aFilename
		do: [ :stream |
			stream binary.
			aBlock value: stream ]! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/29/2016 09:12'!
fileNamed: aFilename writeStreamDo: aBlock
	^ FileStream
		forceNewFileNamed: aFilename
		do: [ :stream |
			stream binary.
			aBlock value: stream ]! !

!FLSqueakPlatform methodsFor: 'accessing-system' stamp: 'MaxLeske 4/30/2016 15:35'!
imageName
	^ Smalltalk image imageName copyAfterLast: (Smalltalk globals at: #FileDirectory) slash first! !

!FLSqueakPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:57'!
isBigEndian
	^ Smalltalk isBigEndian! !

!FLSqueakPlatform methodsFor: 'testing' stamp: 'MaxLeske 4/30/2016 13:10'!
isSqueak
	^ true! !

!FLSqueakPlatform methodsFor: 'accessing-compiler' stamp: 'MaxLeske 2/22/2016 14:56'!
renamedMethodCopyOf: aMethod selector: aSymbol
	| source |
	source := (aMethod methodClass decompilerClass new
		decompile: aSymbol
		in: aMethod methodClass
		method: aMethod) decompileString.
	"Fix compiler glitch"
	source := source
		copyReplaceAll: 'selector: #=>', String cr
		with: 'selector: #= >', String cr.
	^ (aMethod methodClass compilerClass new
		compile: source
		in: aMethod methodClass
		notifying: nil
		ifFail: []) generate! !

!FLSqueakPlatform methodsFor: 'accessing-system' stamp: 'MaxLeske 2/21/2016 13:22'!
useAuthor: aString during: aBlock
	| previous utilities |
	utilities := (Smalltalk at:#Utilities).
	previous := utilities authorInitialsPerSe.
	utilities setAuthorInitials: aString.
	^ aBlock ensure: [ utilities setAuthorInitials: previous ]! !
